#!/usr/bin/csh -f

# Copyright (C) 2021 Terence Kelly.  All rights reserved.

set h = maxwarn_hello.c
set o = maxwarn_hello
set f = maxwarn_flags

foreach compiler ( gcc g++ )
    echo ''
    if ("gcc" == $compiler) then
        set std = c17
        set gcmd = '/^[cx] /{print $2}'
        echo 'C warning flags:'
    else
        set std = c++17
        set gcmd = '/^[px] /{print $2}'
        echo 'C++ warning flags:'
    endif
    echo ''
    echo `gawk "$gcmd" $f`
    echo ''
    foreach opt ( -O0 -O3 )
        echo ''
        echo "compile with $compiler language $std optimization $opt"
        echo ''
        rm -f $o
        $compiler -std=$std `gawk "$gcmd" $f` $opt -o $o $h
        if (! -e $o) then
            echo 'ERROR:  no output file, compile failed'
            exit
        endif
        echo 'run executable:'
        ./$o
        rm -f $o
        echo ''
    end
end
